/**
 * Copyright IBM Corp. 2021, 2026
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktn from 'cdktn';
export interface DataDatabricksUserConfig extends cdktn.TerraformMetaArguments {
    /**
    * Specifies whether to use account-level or workspace-level API. Valid values are `account` and `workspace`. When not set, the API level is inferred from the provider host.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.116.0/docs/data-sources/user#api DataDatabricksUser#api}
    */
    readonly api?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.116.0/docs/data-sources/user#id DataDatabricksUser#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.116.0/docs/data-sources/user#user_id DataDatabricksUser#user_id}
    */
    readonly userId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.116.0/docs/data-sources/user#user_name DataDatabricksUser#user_name}
    */
    readonly userName?: string;
    /**
    * provider_config block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.116.0/docs/data-sources/user#provider_config DataDatabricksUser#provider_config}
    */
    readonly providerConfig?: DataDatabricksUserProviderConfig;
}
export interface DataDatabricksUserProviderConfig {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.116.0/docs/data-sources/user#workspace_id DataDatabricksUser#workspace_id}
    */
    readonly workspaceId?: string;
}
export declare function dataDatabricksUserProviderConfigToTerraform(struct?: DataDatabricksUserProviderConfigOutputReference | DataDatabricksUserProviderConfig): any;
export declare function dataDatabricksUserProviderConfigToHclTerraform(struct?: DataDatabricksUserProviderConfigOutputReference | DataDatabricksUserProviderConfig): any;
export declare class DataDatabricksUserProviderConfigOutputReference extends cdktn.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktn.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataDatabricksUserProviderConfig | undefined;
    set internalValue(value: DataDatabricksUserProviderConfig | undefined);
    private _workspaceId?;
    get workspaceId(): string;
    set workspaceId(value: string);
    resetWorkspaceId(): void;
    get workspaceIdInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/databricks/databricks/1.116.0/docs/data-sources/user databricks_user}
*/
export declare class DataDatabricksUser extends cdktn.TerraformDataSource {
    static readonly tfResourceType = "databricks_user";
    /**
    * Generates CDKTN code for importing a DataDatabricksUser resource upon running "cdktn plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataDatabricksUser to import
    * @param importFromId The id of the existing DataDatabricksUser that should be imported. Refer to the {@link https://registry.terraform.io/providers/databricks/databricks/1.116.0/docs/data-sources/user#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataDatabricksUser to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktn.TerraformProvider): cdktn.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/databricks/databricks/1.116.0/docs/data-sources/user databricks_user} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataDatabricksUserConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataDatabricksUserConfig);
    get aclPrincipalId(): string;
    get active(): cdktn.IResolvable;
    get alphanumeric(): string;
    private _api?;
    get api(): string;
    set api(value: string);
    resetApi(): void;
    get apiInput(): string | undefined;
    get applicationId(): string;
    get displayName(): string;
    get externalId(): string;
    get home(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get repos(): string;
    private _userId?;
    get userId(): string;
    set userId(value: string);
    resetUserId(): void;
    get userIdInput(): string | undefined;
    private _userName?;
    get userName(): string;
    set userName(value: string);
    resetUserName(): void;
    get userNameInput(): string | undefined;
    private _providerConfig;
    get providerConfig(): DataDatabricksUserProviderConfigOutputReference;
    putProviderConfig(value: DataDatabricksUserProviderConfig): void;
    resetProviderConfig(): void;
    get providerConfigInput(): DataDatabricksUserProviderConfig | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
